SystemOrganization addCategory: #'Glamour-Helpers'!

OrderedCollection variableSubclass: #GLMMultiValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMMultiValue commentStamp: 'tg 12/19/2009 00:16' prior: 0!
GLMMultiValue is helper class that is used in #glamourValue:.!

!GLMMultiValue methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
asGlamorousArray 
	 
	^self asArray! !

!GLMMultiValue methodsFor: 'testing' stamp: 'tg 9/9/2009 01:02'!
asGlamorousMultiValue
	^ self! !

!String methodsFor: '*Glamour-Helpers' stamp: 'FabrizioPerin 5/31/2010 15:04'!
glamourString
	^ self! !

!ArrayedCollection class methodsFor: '*Glamour-Helpers' stamp: 'tg 5/4/2009 22:14'!
with: anObject withAll: aCollection

	| newArray |
	newArray := self new: aCollection size + 1.
	newArray at: 1 put: anObject.
	newArray
		replaceFrom: 2
		to: newArray size
		with: aCollection.
	^newArray
	
"Array with: 1 withAll: #(2 3 4)"! !

!Symbol methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	anArray size < 1 ifTrue: [^nil]. 
	^anArray first perform: self! !

!Boolean methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	^self! !

!BlockClosure methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	"This is the same as valueWithPossibleArgs: from squeak. 
	Unfortunately, VW's cullValue: is incompatible." 
	 
	self numArgs = 0 ifTrue: [^self value]. 
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray]. 
	self numArgs > anArray size 
		ifTrue: 
			[^self 
				valueWithArguments: anArray , (Array new: self numArgs - anArray size)]. 
	^self 
		valueWithArguments: 
			(anArray 
				copyFrom: 1 
				to: self numArgs)! !

!Text methodsFor: '*Glamour-Helpers' stamp: 'FabrizioPerin 5/31/2010 15:04'!
glamourString
	^ self! !

!Announcer methodsFor: '*Glamour-Helpers' stamp: 'tg 1/11/2010 01:03'!
reset
	subscriptions := nil! !

Announcer subclass: #GLMAnnouncer
	instanceVariableNames: 'suspendAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMAnnouncer methodsFor: 'announce' stamp: 'tg 2/17/2010 23:04'!
announce: anAnnouncement
	| announcement |
	announcement := anAnnouncement asAnnouncement.
	subscriptions ifNil: [ ^ announcement ].
	self suspendAll ifTrue: [ ^ announcement ].
	subscriptions keysAndValuesDo: [ :class :actions |
		(class handles: announcement) 
			ifTrue: [ actions valueWithArguments: (Array with: announcement) ] ].
	^ announcement! !

!GLMAnnouncer methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:27'!
announcer 
	^ self! !

!GLMAnnouncer methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:22'!
resetAnnouncer
	self reset! !

!GLMAnnouncer methodsFor: 'as yet unclassified' stamp: 'tg 2/17/2010 23:04'!
suspendAll
	^ suspendAll ifNil: [ suspendAll := false ].! !

!GLMAnnouncer methodsFor: 'as yet unclassified' stamp: 'tg 2/18/2010 00:00'!
suspendAllWhile: aBlock
	| previousSuspensionState |
	previousSuspensionState := suspendAll.
	suspendAll := true.
	aBlock value.
	suspendAll := previousSuspensionState.! !

Object subclass: #GLMAllNotNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMAllNotNilCondition commentStamp: '<historical>' prior: 0!
Used to test if all defined arguments of a condition or not nil.

We use this as a default condition for presentations. Usually, you will want to define a condition as a block such as '[ :class :category | (class isKindOf: Class) and: [ category isKindOf: Symbol ] ]' (or something like that) but sometimes you just want to make sure that all arguments are defined. Since we do not know the number of arguments in advance, we use this class to interpret #glamourValueWithArgs: and return true if all arguments are not nil.!

!GLMAllNotNilCondition methodsFor: 'glamour' stamp: 'DamienCassou 9/10/2009 19:54'!
glamourValueWithArgs: anArray 
	 
	^anArray allSatisfy: [:each | each notNil]! !

Object subclass: #GLMLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

GLMLogger class
	instanceVariableNames: 'nullInstance instance'!

!GLMLogger commentStamp: 'tg 5/24/2010 17:00' prior: 0!
This is the abstract class for the Glamour loggers. These classes are typically used for debugging hte highly dynamic Glamour model.!

GLMLogger class
	instanceVariableNames: 'nullInstance instance'!

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:03'!
instance
	^ instance ifNil: [
		instance := self nullInstance ]! !

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:04'!
instance: aLogger
	instance := aLogger ! !

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 16:47'!
nullInstance 
	^ nullInstance ifNil: [
		nullInstance := GLMNullLogger new ]! !

!GLMLogger classSide methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:08'!
reset
	instance := nil! !

!GLMLogger methodsFor: 'logging' stamp: 'tg 5/24/2010 16:45'!
logAnnouncement: anAnnouncement from: aGLMObject 
	
	! !

GLMLogger subclass: #GLMMemoryLogger
	instanceVariableNames: 'announcements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMMemoryLogger commentStamp: 'tg 5/24/2010 16:59' prior: 0!
This class stores the announcements raised by the Glamour model in an ordered collection.

The collection can later be used for debugging.!

!GLMMemoryLogger methodsFor: 'accessing' stamp: 'tg 5/24/2010 17:30'!
announcements
	^ announcements! !

!GLMMemoryLogger methodsFor: 'accessing' stamp: 'tg 5/24/2010 17:30'!
announcements: anObject
	announcements := anObject! !

!GLMMemoryLogger methodsFor: 'initialize-release' stamp: 'tg 5/24/2010 16:46'!
initialize 
	announcements := OrderedCollection new! !

!GLMMemoryLogger methodsFor: 'logging' stamp: 'tg 5/24/2010 17:31'!
logAnnouncement: anAnnouncement from: aGLMObject 
	announcements add: anAnnouncement! !

GLMLogger subclass: #GLMNullLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMNullLogger commentStamp: 'tg 5/24/2010 16:58' prior: 0!
This class simply implements the Null pattern.!

Object subclass: #GLMPortUpdater
	instanceVariableNames: 'portSymbol valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	(anArray first pane port: self portSymbol) 
		value: (self valueBlock glamourValueWithArgs: anArray)! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
portSymbol 
	 
	^portSymbol! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
portSymbol: anObject 
	 
	portSymbol := anObject! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
valueBlock 
	 
	^valueBlock! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
valueBlock: anObject 
	 
	valueBlock := anObject! !

Object subclass: #GLMSomeNotNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMSomeNotNilCondition methodsFor: 'as yet unclassified' stamp: 'tg 12/31/2009 00:22'!
glamourValueWithArgs: anArray 
	 
	^anArray anySatisfy: [:each | each notNil]! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
asGlamorousArray 
	 
	^Array with: self! !

!Object methodsFor: '*Glamour-Helpers' stamp: 'tg 9/9/2009 01:02'!
asGlamorousMultiValue
	^ GLMMultiValue with: self! !

!Object methodsFor: '*Glamour-Helpers' stamp: 'tg 9/12/2009 08:43'!
glamourString 
	"This method tries to circumvent the missing displayString from Squeak" 
	 
	^ (self class canUnderstand: #asString) 
		ifTrue: [self asString] 
		ifFalse: [self displayString]! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValue: anObject 
	 
	| args | 
	args := anObject asGlamorousArray. 
	^self glamourValueWithArgs: args! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	^self! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderObject: self! !
